--[[
TODO:
	
CHANGELOG:
	1.0	  Initial release
	1.01  Added missing LibStub
	1.02  Added missing AceEvent and CallbackHandler, updated TOC to 6.0.2
]]

FixParty = LibStub("AceAddon-3.0"):NewAddon("FixParty", "AceEvent-3.0")

local GroupMembers = 0

local diff = {}
diff[1] = DUNGEON_DIFFICULTY1
diff[2] = DUNGEON_DIFFICULTY2
diff[8] = "Challenge Mode"

local loot = {}
loot["freeforall"] = ERR_SET_LOOT_FREEFORALL
loot["group"] = ERR_SET_LOOT_GROUP
loot["roundrobin"] = ERR_SET_LOOT_ROUNDROBIN
loot["master"] = ERR_SET_LOOT_MASTER
loot["needbeforegreed"] = ERR_SET_LOOT_NBG

local threshold = {}
threshold[0] = ITEM_QUALITY0_DESC
threshold[1] = ITEM_QUALITY1_DESC
threshold[2] = ITEM_QUALITY2_DESC
threshold[3] = ITEM_QUALITY3_DESC
threshold[4] = ITEM_QUALITY4_DESC
threshold[5] = ITEM_QUALITY5_DESC
threshold[6] = ITEM_QUALITY6_DESC
threshold[7] = ITEM_QUALITY7_DESC

function FixParty:OnInitialize()
	FixParty:RegisterEvent("GROUP_ROSTER_UPDATE")
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM",FixPartyFilterChat) -- Used to alter 'raid group' to 'party', hide unnecessary messages
end

function FixPartyFilterChat(self,event,msg, ...) -- true to block, false to allow
	--if msg == "Dungeon Difficulty set to Heroic." then return true
	--elseif msg == "Looting changed to Group Loot." then return true
	--elseif msg == "Loot threshold set to Uncommon." then return true
	
	if strmatch(msg,"Dungeon Difficulty set to ") and GetNumGroupMembers() == 1 then return true
	elseif strmatch(msg,"Looting changed to ") and GetNumGroupMembers() == 1 then return true
	elseif strmatch(msg,"Loot threshold set to ") and GetNumGroupMembers() == 1 then return true
	
	elseif strmatch(msg,"([^ ]+) has joined the raid group.") and IsInRaid() == false then
		local name = strmatch(msg,"([^ ]+) has joined the raid group.")
		local msg = name.." has joined the party."
		return false, msg, ...
	
	elseif strmatch(msg,"([^ ]+) has left the raid group.") and IsInRaid() == false then
		local name = strmatch(msg,"([^ ]+) has left the raid group.")
		local msg = name.." has left the party."
		return false, msg, ...
	
	else return false
	end
end

function FixParty:ShowGroupMessages()
	local r,g,b = ChatTypeInfo["SYSTEM"]["r"],ChatTypeInfo["SYSTEM"]["g"],ChatTypeInfo["SYSTEM"]["b"]
	DEFAULT_CHAT_FRAME:AddMessage(string.format(ERR_DUNGEON_DIFFICULTY_CHANGED_S,diff[GetDungeonDifficultyID()]),r,g,b,GetChatTypeIndex("SYSTEM"))
	DEFAULT_CHAT_FRAME:AddMessage(loot[GetLootMethod()],r,g,b,GetChatTypeIndex("SYSTEM"))
	DEFAULT_CHAT_FRAME:AddMessage(string.format(ERR_SET_LOOT_THRESHOLD_S,threshold[GetLootThreshold()]),r,g,b,GetChatTypeIndex("SYSTEM"))
end

function FixParty:GROUP_ROSTER_UPDATE(...)
	if IsInRaid() == false then
		if GroupMembers < GetNumGroupMembers() and GetNumGroupMembers() > 1 then
			PlaySound("igPlayerInviteAccept") -- Play sound if someone just joined (members are more than before) and we're not in a raid
			if GetNumGroupMembers() == 2 then
				FixParty:ShowGroupMessages() -- Show loot/difficulty info when creating a group
			end
		end
	end
	GroupMembers = GetNumGroupMembers()
end